package com.scientificCalculaor.view
{
	import flash.events.MouseEvent;
	import flash.text.ReturnKeyLabel;
	import flash.ui.Mouse;
	
	import mx.events.ModuleEvent;
	
	import org.robotlegs.mvcs.Mediator;
	
	import spark.skins.spark.windowChrome.MacCloseButtonSkin;
	
	public class scientificCalculatorMediator extends Mediator
	{
		[Inject]public var view:scientificCalculatorView;
		
		private var opt:String="";
		 
		 private var no:String;
		 private var fragmentList:Array;
		 private var digitFlag:Boolean;
		 private var calcFlag:Boolean;
		 private var num:Number;
		 private var preNum:Number;
		 private var preOpt:String = "";
		 private var tempOptCount:Number = 0;
		 private var equalFlag:Boolean;
		 private var optCount:Number=0;
		 private var algFlag:Boolean=false;
		 private var inputText:String = "";
		 private var result:Number = 0;
		 private var zeroIndexFlag:Boolean;
		 private var alg2Array:Array = new Array("^","√","!");
		 private var dotFlag:Boolean;
		
		
		public function scientificCalculatorMediator()
		{
			super();
		}
		override public function onRegister():void
		{
			
			eventMap.mapListener(view.n0,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.n1,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.n2,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.n3,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.n4,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.n5,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.n6,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.n7,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.n8,MouseEvent.CLICK,digitClicked);
			eventMap.mapListener(view.n9,MouseEvent.CLICK,digitClicked);
			
			eventMap.mapListener(view.na,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.ns,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.nm,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.nd,MouseEvent.CLICK,optClicked);
			eventMap.mapListener(view.mod,MouseEvent.CLICK,optClicked);
			
			eventMap.mapListener(view.neq,MouseEvent.CLICK,equalClick);
			eventMap.mapListener(view.b,MouseEvent.CLICK,backClicked);
			eventMap.mapListener(view.clear,MouseEvent.CLICK,clearClicked);
			eventMap.mapListener(view.ce,MouseEvent.CLICK,ceClicked);
			eventMap.mapListener(view.dot,MouseEvent.CLICK,dotClicked);
			
			eventMap.mapListener(view.sqroot,MouseEvent.CLICK,sqrootClicked);
			eventMap.mapListener(view.x2,MouseEvent.CLICK,x2Clicked);
			eventMap.mapListener(view.x3,MouseEvent.CLICK,x3Clicked);
			eventMap.mapListener(view.xfact,MouseEvent.CLICK,xfact);
			eventMap.mapListener(view.xsqrooty,MouseEvent.CLICK,optClicked2);
			eventMap.mapListener(view.ypowx,MouseEvent.CLICK,optClicked1);
			eventMap.mapListener(view.sin,MouseEvent.CLICK,sin);
			eventMap.mapListener(view.cos,MouseEvent.CLICK,cos);
			eventMap.mapListener(view.tan,MouseEvent.CLICK,tan);
			eventMap.mapListener(view.sinInverse,MouseEvent.CLICK,sinInverse);
			eventMap.mapListener(view.cosInverse,MouseEvent.CLICK,cosInverse);
			eventMap.mapListener(view.tanInverse,MouseEvent.CLICK,tanInverse);
			eventMap.mapListener(view.log,MouseEvent.CLICK,log);
			eventMap.mapListener(view.ln,MouseEvent.CLICK,ln);
			eventMap.mapListener(view.pi,MouseEvent.CLICK,pi);
			eventMap.mapListener(view.e,MouseEvent.CLICK,e);
			
			eventMap.mapListener(view.btnAddMem,MouseEvent.CLICK,addMemClicked);
			eventMap.mapListener(view.btnClearMem,MouseEvent.CLICK,clearMemClicked);
			
		}
		
		private function clearMemClicked(e:MouseEvent):void
		{
			view.TareaDisplay.text="";
			
			
		}
		
		private function addMemClicked(e:MouseEvent):void
		{
			var result:String=view.resultDisplay.text;
			view.TareaDisplay.text=result.substr(1);
			
			//var result:Number = calculate();
			//view.TareaDisplay.text=result;
			trace(view.TareaDisplay.text);
			
		}
		
		
		
		
		private function dotClicked(event:MouseEvent):void
		{
			
			digitFlag=false;
			var no:String=view.resultDisplay.text;
			if(no=="")
				no="0";
			var lastChar:String = no.charAt(no.length-1);
			if(isOperator(lastChar)) 
				no=no+"0";
			if(!dotFlag)
			{
			view.resultDisplay.text= no+".";
			trace(view.resultDisplay.text);
			tempOptCount = 0;
			digitFlag =true;
			calcFlag = false;
			
			}
			dotFlag=true;
			
		}
		private function appendText(str:String):void
		{
			var text = view.numDisplay.text;
			if(text=="0")
					text="";
				view.numDisplay.text = text+str;
			
		}
		
		
		
		private function backClicked(even:MouseEvent):void
		{
			var no:String=view.resultDisplay.text;
			if(no=="0")
			{
				var no1:String=view.numDisplay.text;
				if(no1.length>1)
					no1 = no1.substr(0,no1.length-1);
				else
					no1="0";
				view.numDisplay.text = no1;
			}
			
			if(no.length>1)
				no = no.substr(0,no.length-1);
			else
				no="0";
			view.resultDisplay.text = no;
		}
		private function clearClicked(e:MouseEvent):void
		{			
			clearAll();	
		}
		private function ceClicked(event:MouseEvent):void
		{			
			view.resultDisplay.text="0";			
		}
		private function clear():void
		{			
			opt="";
			preOpt="";
			num=0; 
			preNum=0;
			tempOptCount = 0;
			optCount=0;
			digitFlag = false;	
			view.numDisplay.text="";	
		}
		private function clearAll():void
		{			
			clear();
			view.numDisplay.text="0";		
			view.resultDisplay.text="";	
			dotFlag=false;
		}
		private function isOperator(no:String):Boolean
		{
			var flag:Boolean = false;
			if(no=="+" || no=="-" || no=="/" || no=="*" || no=="%" || no=="^" || no=="√")
			{
				flag=true;
			}
			if(no=="+-" || no=="--" || no=="/-" || no=="*-" || no=="%-")
			{
				flag=true;
			}
			return flag;
		} 
		private function isDigit(value : String) : Boolean 
		{
			
			if(isNaN(Number(value)))
				return false;
			else
				return false;
			
		}
		private function calculate():Number
		{
			fragmentList = new Array();
			var numText:String=view.numDisplay.text;
			var resText:String=view.resultDisplay.text;
			if(!calcFlag && digitFlag)
			{
				var ch:String = numText.charAt(numText.length-1);
				if(isOperator(ch))
				{
					numText = numText + resText;
				}
			}
			toArray(numText);
			var text:String="";
			var arr:Array = fragmentList;
			var tempResult:Number=0;
			var tempOpt:String="";
			var i:Number;
			for(i=0;i<arr.length;i++)
			{
				var str=arr[i];
				if(!isOperator(str))
				{
					if(!isDigit(str) && isAlgebric2(str))
					{
						var no:Number = calculateAlg2(str);
						if(tempOpt=="")
							tempResult = no;
						else
							tempResult = calcToken(tempResult,tempOpt,no);
						
					}
					else
					{						
						var no:Number = Number(str);
						if(tempOpt=="")
							tempResult = no;
						else
							tempResult = calcToken(tempResult,tempOpt,no);							
						
					}
					
				}
				else if(isOperator(str))
				{
					tempOpt = str;
				}
			}
			if(arr.length==0)
				tempResult = Number(numText); 
				return tempResult;
		}
		private function calcToken(tempResult:Number,opt:String,no:Number):Number
		{
			var total:Number=0;
			if(opt.length==2 && opt.charAt(opt.length-1)=='-')
			{
				opt=opt.charAt(0);
				no = Number("-"+no);
			}
			
			if(opt=="+")
				total=tempResult+no;			
			else if(opt=="-")
			{
				total=tempResult-no;				
			}
			else if(opt=="*")
				total=tempResult*no;
			else if(opt=="/")
				total=tempResult/no;
			else if(opt=="%")
				total=tempResult%no;
		var precision:Number = getPrecision(preNum, no);
			if(precision>0)
			{
				total = setPrecision(total,precision);
			}
			return total;
		}
		private function toArray(text:String):void
		{
			
			var index:Number = getIndex(text);
			var opt:String = getOperator(text);
			
			if(index==0 && opt=="-")
			{
				zeroIndexFlag=true;
				var frag2:String = text.substr(1);				
				toArray(frag2);
			}
			else if(index>0)
			{
				var frag1:String = text.substr(0,index);
				if(zeroIndexFlag)
				{
					frag1="-"+frag1;
					zeroIndexFlag=false;
				}
				var index2:Number = index+1;
				if(opt.length==2 && opt.charAt(opt.length-1)=='-')
				{
					index2=index+2;
				}
				var frag2:String = text.substr(index2);
				
				fragmentList.push(frag1);
				fragmentList.push(opt);	
				
				if(getIndex(frag2)<0)
				{
					fragmentList.push(frag2);
				}
				else
					toArray(frag2);
				
			}
			else
				fragmentList.push(text);
			
		}
		private function isAlgebric2(text:String):Boolean
		{
			var flag:Boolean=false;			
			var i:Number;
			for(i=0;i<alg2Array.length;i++)
			{				
				var ind:Number = text.indexOf(alg2Array[i]);
				if(ind>=0)
				{
					flag=true;
					break;
				}
			}
			return flag;
		}
		private function calculateAlg2(text:String):Number
		{
			
			var total:Number=0;
			
			var index:Number = getIndexAlg2(text);
			var opt:String = getOperatorAlg2(text);
			
			if(index==0)
			{
				var frag:String = text.substr(1);
				var no:Number = Number(frag);
				if(opt=="√")
				{
					total = Math.sqrt(no);
				}
			}
			else if(index>0)
			{
				var frag1:String = text.substr(0,index);				
				var index2:Number = index+1;
				
				var frag2:String = text.substr(index2);
				
				var no1:Number = Number(frag1);
				var no2:Number = Number(frag2);
				
				if(opt=="^")
				{
					total = Math.pow(no1,no2);
				}
				if(opt=="√")
				{
					total = Math.round((Math.pow(no2,1/no1)));
					
					trace(total);
				}
				if(opt=="!")
				{
					var factorial:Number=1;
					var i:Number=1;
					while (i <=no1 ) 
					{
						factorial = factorial * i;
						i = i+1;
						
					}
					total=factorial;
					
				}
				if(opt=="(")
				{
					
				}
				if(opt==")")
				{
					
				}
				
			}
			
			return total;
		}
		
		
		
		
	
		private function e(e:MouseEvent):void
		{
			no=Math.E.toString();
			view.resultDisplay.text="="+no;
			
		}
		private function pi(e:MouseEvent):void
		{
			no=Math.PI.toString();
			view.resultDisplay.text="="+no;
			
			
		}
		
		private function xfact(e:MouseEvent):void
		{
			var no:Number=Number(view.resultDisplay.text);
			appendText(no+"!");
		}
		private function sqrootClicked(event:MouseEvent):void
		{
			var no:Number=Number(view.resultDisplay.text);
			appendText("√"+no);
			//view.resultDisplay.text=Math.sqrt(no).toString();
		}
		
		
		private function x2Clicked(event:MouseEvent):void
		{	
			var no:Number=Number(view.resultDisplay.text);
			appendText(no+"^2");
			
			//view.resultDisplay.text=Math.pow(no,2).toString();
			
			
		}
		private function x3Clicked(event:MouseEvent):void
		{
			var no:Number=Number(view.resultDisplay.text);
			
			appendText(no+"^3");
			//view.resultDisplay.text=Math.pow(no,3).toString();
		}		
		private function log(e:MouseEvent):void
		{
			var x:Number=Number(view.resultDisplay.text);
			var y:Number=(Math.log(x))/2.303;
			trace(y);
			view.resultDisplay.text="="+y.toString();
			digitFlag=false;
		
		}
		
		private function ln(e:MouseEvent):void
		{
			var x:Number=Number(view.resultDisplay.text);
			var y:Number=Math.log(x);
			view.resultDisplay.text="="+y.toString();
			digitFlag=false;
			
		}
		
		private function sin(e:MouseEvent):void
		{
			var x:Number=Number(view.resultDisplay.text);
			var y:Number=Math.sin(x);
			trace(y);
			view.resultDisplay.text="="+y.toString();
			digitFlag=false;
		
		}
		
		private function cos(e:MouseEvent):void
		{
			var x:Number= Number(view.resultDisplay.text);
			var y1:Number=Math.cos(x);
			view.resultDisplay.text="="+y1.toString();
			digitFlag=false;
			
		}
		
		private function tan(e:MouseEvent):void
		{
			var x:Number=Number(view.resultDisplay.text);
			var y2:Number=Math.tan(x);
			view.resultDisplay.text="="+y2.toString();
			digitFlag=false;
			
		}
		
		private function sinInverse(e1:MouseEvent):void
		{
			var x:Number=Number(view.resultDisplay.text);
			var y2:Number=Math.asin(x);
			view.resultDisplay.text="="+y2.toString();
			digitFlag=false;
			
		}
		
		private function cosInverse(e:MouseEvent):void
		{
			var x:Number=Number(view.resultDisplay.text);
			var y2:Number=Math.acos(x);
			view.resultDisplay.text="="+y2.toString();
			digitFlag=false;
		}
		private function tanInverse(e:MouseEvent):void
		{
			var x:Number=Number(view.resultDisplay.text);
			var y2:Number=Math.atan(x);
			view.resultDisplay.text="="+y2.toString();
			digitFlag=false;
			
		}		
		
		private function equalClick(event:MouseEvent):void
		{
			var result:Number = calculate();
			view.resultDisplay.text="="+result.toString();
			
			
			clear();
			calcFlag = true;
			equalFlag=true;
			dotFlag=false;
		}
		
		private function digitClicked(event:MouseEvent):void
		{
			
			if(equalFlag)
			{
				
				equalFlag = false;
			}
			
			var cno:String = event.target.label;	
			var no:String=view.resultDisplay.text; 
			if(no=="0")
				no="";
			if(!digitFlag)
				no="";
			view.resultDisplay.text= no+cno;
			
			tempOptCount = 0;
			digitFlag =true;
			calcFlag = false;
			
			
			
		}
		
		private function optClicked(event:MouseEvent):void
		{
			if(equalFlag)
			{
				
				equalFlag = false;
			}
			var no:String = view.numDisplay.text;
			var no0:String = view.resultDisplay.text;
			opt=event.target.label;
			
			if(no0.charAt(0)=="=")
			{
				no0 = no0.substr(1);
			}
			
			
			if(no=="0")
				no="";
			
			var ch:String = no.charAt(no.length-1);
			
			if(isOperator(ch))
			{
				if(opt!="-" && digitFlag==false)
				{
					return;
				}
				else if(opt=="-" && digitFlag==false)
				{
					view.numDisplay.text=no+opt;
					return;
				}
				
			}
			
			var result:Number=calculate(); 			
			view.resultDisplay.text="="+result;
			calcFlag = true;
			
			
			view.numDisplay.text=no+no0+opt;
			
			
			tempOptCount++;
			digitFlag = false;
			dotFlag=false;
			
		}
		private function optClicked1(event:MouseEvent):void
		{
			if(equalFlag)
			{
				
				equalFlag = false;
			}
			var no:String = view.numDisplay.text;
			var no0:String = view.resultDisplay.text;
			opt="^";
			
			if(no0.charAt(0)=="=")
			{
				no0 = no0.substr(1);
			}
			
			
			if(no=="0")
				no="";
			
			var ch:String = no.charAt(no.length-1);
			
			if(isOperator(ch))
			{
				if(opt!="-" && digitFlag==false)
				{
					return;
				}
				else if(opt=="-" && digitFlag==false)
				{
					view.numDisplay.text=no+opt;
					return;
				}
				
			}
			
			var result:Number=calculate(); 			
			view.resultDisplay.text="="+result;
			calcFlag = true;
			
			
			view.numDisplay.text=no+no0+opt;
			
			
			tempOptCount++;
			digitFlag = false;
			
		}
		private function optClicked2(event:MouseEvent):void
		{
			if(equalFlag)
			{
				
				equalFlag = false;
			}
			var no:String = view.numDisplay.text;
			
			var no0:String = view.resultDisplay.text;
			
			opt="√";
			
			if(no0.charAt(0)=="=")
			{
				no0 = no0.substr(1);
			}
			
			
			if(no=="0")
				no="";
			
			var ch:String = no.charAt(no.length-1);
			
			if(isOperator(ch))
			{
				if(opt!="-" && digitFlag==false)
				{
					return;
				}
				else if(opt=="-" && digitFlag==false)
				{
					view.numDisplay.text=no+opt;
					return;
				}
				
			}
			
			var result:Number=calculate(); 	
			
			view.resultDisplay.text="="+result;
			calcFlag = true;
			
			
			view.numDisplay.text=no+no0+opt;
			trace(view.numDisplay.text);
			
			tempOptCount++;
			digitFlag = false;
			
		}
		private function getIndex(text:String):Number
		{
			var index:Number;
			var arr:Array = new Array("+","-","*","/","%","+-","--","*-","/-","%-");
			var i:Number;
			for(i=0;i<arr.length;i++)
			{
				if(i==0)
					index=text.indexOf(arr[i]);
				else
				{
					var ind:Number = text.indexOf(arr[i]);
					if(ind>=0 && (index>=0 && ind<index) || (index<0))
					{
						index = ind;
					}
				}
			}
			return index;
		}
		private function getIndexAlg2(text:String):Number
		{
			var index:Number;
			var i:Number;
			for(i=0;i<alg2Array.length;i++)
			{
				if(i==0)
					index=text.indexOf(alg2Array[i]);
				else
				{
					var ind:Number = text.indexOf(alg2Array[i]);
					if(ind>=0 && (index>=0 && ind<index) || (index<0))
					{
						index = ind;
					}
				}
			}
			return index;
		}
		private function getOperator(text:String):String
		{
			var index:Number;
			var opt:String;
			var arr:Array = new Array("+-","--","*-","/-","%-","+","-","*","/","%");
			var i:Number;
			for(i=0;i<arr.length;i++)
			{
				if(i==0)
				{
					opt= arr[i];
					index=text.indexOf(opt);					
				}
				else
				{					
					var ind:Number = text.indexOf(arr[i]);
					if(ind>=0 && (index>=0 && ind<index) || (index<0))
					{
						index = ind;
						opt= arr[i];
					}
				}
			}
			return opt;
		}
		
		private function getOperatorAlg2(text:String):String
		{
			var index:Number;
			var opt:String;
			var i:Number;
			for(i=0;i<alg2Array.length;i++)
			{
				if(i==0)
				{
					opt= alg2Array[i];
					index=text.indexOf(opt);					
				}
				else
				{					
					var ind:Number = text.indexOf(alg2Array[i]);
					if(ind>=0 && (index>=0 && ind<index) || (index<0))
					{
						index = ind;
						opt= alg2Array[i]; 
					}
				}
			}
			return opt;
		}
		private function getPrecision(no1:Number,no2:Number):Number
		{
			var precision:Number = 0;
			var index1:Number = -1;
			var index2:Number = -1;
			
			var str1:String = no1.toString();
			var str2:String = no2.toString();
			
			index1= str1.indexOf(".");
			index2= str2.indexOf(".");
			var len1:Number=0;
			var len2:Number=0;
			
			if(index1>0)
			{
				var temp1 = str1.substr(index1+1);
				len1 = temp1.length;
			}
			if(index2>0)
			{
				var temp2 = str2.substr(index2+1);
				len2 = temp2.length;
			}
			
			if(len1>len2)
				precision = len1;
			else
				precision = len2;
			
			
			return precision;
		}
		private function setPrecision(number:Number,precision:Number):Number
		{
			precision = Math.pow(10,precision);
			return Math.round(number*precision)/precision;
		}
		
		
		
		
		
		
	}
}